#include <EXTERN.h>
#include <perl.h>

static PerlInterpreter * my_perl;

/* defined in xsinit.c, created by ExtUtils::Embed */
EXTERN_C void xs_init (pTHX);

int
start_interpreter (void)
{
	/* command-line arguments for the new interpreter. */
	char * argv[] = {
		"",	/* empty progname.  we're spoofing, you know. */
		"-w",	/* i like warnings. */
		"-e", "1"	/* execute an empty command-line program.
				   this makes the interpreter happy and
				   keeps it from waiting for input on stdin,
				   so that we don't have to feed it an
				   actual filename. */
	};
	char startup_code[] = { "use Gtk2;" };

	my_perl = perl_alloc ();
	if (!my_perl)
		return FALSE;
	perl_construct (my_perl);
	PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
	perl_parse (my_perl, xs_init, sizeof(argv)/sizeof(argv[0]), argv, NULL);
	perl_run (my_perl);

	eval_pv (startup_code, TRUE);

	return TRUE;
}

void
shut_down_interpreter (void)
{
	perl_destruct (my_perl);
	perl_free (my_perl);
	PERL_SYS_TERM ();
}


#include <gtk/gtk.h>

void
gtk_module_init (gint *argc,
		 gchar *** argv)
{
	char code[] = {
	"Glib::Timeout->add (1000, sub {"
	"	$window = Gtk2::MessageDialog->new (undef, [], 'info', 'ok',"
	"					    'hello from the module');"
	"	$window->show;"
	"	0;"
	"});"
	};
	start_interpreter ();
	g_atexit (shut_down_interpreter);

	eval_pv (code, TRUE);
}
